// by Alexander Ilyin
// plugin configuration dialog

#include "cfg_dlg.h"
#include "resource.h"
#include "error.h"
#include "plugin.h"
#include "macros.h"


//DLGPROC CfgDlgProc;
BOOL CALLBACK CfgDlgProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);


//void CfgDlg (HWND parent, HINSTANCE dll_instance)
int CfgDlg (HWND parent, HINSTANCE dll_instance)
{
	int i;

	i = DialogBox (dll_instance, MAKEINTRESOURCE(IDD_DIALOG1), parent, CfgDlgProc);
	return i;
}

// returns 1, if exactly one button is checked
bool DlgGetRadioButtonIx (u32& checked_ix, HWND hwnd, u32 button_first, u32 buttons_num)
{
	u32 checked_num;
	u32 checked;
	u32 ix;

	checked_num = 0;
	ix = -1;
	FORI0(buttons_num)
	{
//		wnd = GetDlgItem (hwnd, );
		checked = IsDlgButtonChecked (hwnd, button_first + i);
		switch (checked)
		{
		case BST_CHECKED:
			ix = i;
			checked_num++;
			break;
		case BST_UNCHECKED:
			break;
		default:
			return 0;
		}
	}
	if (checked_num == 1)
	{
		checked_ix = ix;
		return 1;
	}
// wrong number of checked buttons
	return 0;
}

BOOL CALLBACK CfgDlgProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	bool r;
	BOOL B_r;
//	UINT i;
//	u32 ix;

	switch (msg)
	{
	case WM_INITDIALOG:
		A(packtype_hog < 2);
		A(packtype_wad);
		A(packtype_wad < 3);
//		B_r = CheckRadioButton (hwnd, , , packtype_hog);
		B_r = CheckDlgButton (hwnd, IDC_RADIO1 + packtype_hog, BST_CHECKED);
		A(B_r);
		B_r = CheckDlgButton (hwnd, IDC_RADIO3 + packtype_wad, BST_CHECKED);
		A(B_r);
		return 1;
	case WM_COMMAND:
		switch (wparam)
		{
		case IDOK:
			r = DlgGetRadioButtonIx (packtype_hog, hwnd, IDC_RADIO1, 2);
			A(r);
			r = DlgGetRadioButtonIx (packtype_wad, hwnd, IDC_RADIO3, 3);
			A(r);
		case IDCANCEL:
//			B_r = EndDialog (hwnd, 0);
			B_r = EndDialog (hwnd, wparam);
			return 1;
		}
		break;
	}

	return 0;
}

