#pragma once

#include "types.h"
#include <windows.h>
#include "wcxhead.h"


// +++ settings +++
extern u32 packtype_hog;
extern u32 packtype_wad;
// --- settings ---

typedef HANDLE __stdcall OpenArchive_t (tOpenArchiveData* archive_data);
typedef HANDLE __stdcall OpenArchiveW_t (tOpenArchiveDataW* archive_data);
typedef int __stdcall CloseArchive_t (HANDLE h_arc_data);
typedef int __stdcall ReadHeader_t (HANDLE h_arc_data, tHeaderData* header_data);
typedef int __stdcall ProcessFile_t (HANDLE h_arc_data, int operation, LPSTR dest_path, LPSTR dest_name);
typedef void __stdcall SetProcessDataProc_t (HANDLE h_arc_data, tProcessDataProc process_data_proc);
typedef void __stdcall SetProcessDataProcW_t (HANDLE h_arc_data, tProcessDataProcW process_data_proc);
// *remove me (we don't manage/enhance Totalcmd API)
// ==== non WCX subroutines ====
//typedef bool __stdcall PackFilesToFile_t (u32& pack_result, const char* format, const char* packed_file, const char* src_path, const char* add_list);

