#pragma once

#include "types.h"
#include "pack_base.h"


#pragma pack(push, 1)

struct wad_header_t
{
//	char id[4];
	u32 numlumps;
	u32 infotableofs;
};

struct wad_entry_t
{
	u32 filepos;
	u32 filelen;
	char name[8];
};

#pragma pack(pop)

class Wad : virtual public PackBase
{
public:
//	Wad ();
	bool SetHdrBuf ();
	bool HdrParse (bool& is_valid);
	bool TypeSetup ();
	bool EntryGetName ();
	bool EntryReaderPost (bool& is_valid);
	bool EntryForm ();
	bool WriteFinish ();

public:
	wad_header_t m_buf_hdr;
	wad_entry_t m_buf_entry;
// *any size, lets say beginning from 13 (8 + 1 + 3 + 1) and higher
	char m_name_buf[20];
	u32 m_type_cur;
};

