#pragma once

#include "types.h"
#include "pack_base.h"


#pragma pack(push, 1)

struct pak_header_t
{
//	char id[4];
	u32 dirofs;
	u32 dirlen;
};

struct pak_entry_t
{
	char name[56];
	u32 filepos;
	u32 filelen;
};

#pragma pack(pop)

class Pak : virtual public PackBase
//class __declspec(dllexport) Pak : virtual public PackBase
{
public:
//	Pak ();
	bool SetHdrBuf ();
	bool HdrParse (bool& is_valid);
	bool TypeSetup ();
	bool EntryReaderPost (bool& is_valid);
	bool EntryForm ();
	bool WriteFinish ();

public:
	pak_header_t m_buf_hdr;
	pak_entry_t m_buf_entry;
};

